import { IAlgorithm, IChromosome, IPopulation, IFitness, ISelection, ICrossover, IMutation, IReinsertion, ITermination } from '..';
export declare abstract class AlgorithmBase implements IAlgorithm {
    protected _generationNumber: number;
    protected _offspringNumber: number;
    private _initialized;
    get generationNumber(): number;
    get offspringNumber(): number;
    get initialized(): boolean;
    abstract get population(): IPopulation;
    abstract get fitness(): IFitness;
    abstract get selection(): ISelection;
    abstract get crossover(): ICrossover;
    abstract get crossoverProbability(): number;
    abstract get mutation(): IMutation;
    abstract get mutationProbability(): number;
    abstract get reinsertion(): IReinsertion;
    abstract get termination(): ITermination;
    get best(): IChromosome;
    get progress(): number;
    get hasReached(): boolean;
    reset(): Promise<void>;
    protected performReset(): void;
    step(): Promise<void>;
    protected performStep(): void;
}
