import { Acid, IChromosome } from '..';
export declare abstract class ChromosomeBase implements IChromosome {
    private acids;
    fitness: number | undefined;
    protected constructor(_length: number);
    createFromAcids(acids: Array<Acid>): void;
    get length(): number;
    getAcid(index: number): Acid;
    setAcid(index: number, acid: Acid): void;
    abstract generateAcid(index: number): Acid;
    generateAcids(): void;
    abstract createNew(): ChromosomeBase;
    clone(): ChromosomeBase;
    copyFrom(from: ChromosomeBase): void;
    protected performCopyFrom(from: IChromosome): void;
    mutation(index: number): void;
}
