"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class CrossoverBase {
    constructor(_parentsNumber, _childrenNumber) {
        this._parentsNumber = _parentsNumber;
        this._childrenNumber = _childrenNumber;
    }
    get parentsNumber() {
        return this._parentsNumber;
    }
    get childrenNumber() {
        return this._childrenNumber;
    }
    cross(parents, probability) {
        return __awaiter(this, void 0, void 0, function* () {
            if (parents.length !== this.parentsNumber) {
                throw new Error('Length is not same.');
            }
            const offspring = yield this.performCross(parents, probability);
            if (offspring.length !== this.childrenNumber) {
                throw new Error('Length is not same.');
            }
            return offspring;
        });
    }
}
exports.CrossoverBase = CrossoverBase;
//# sourceMappingURL=CrossoverBase.js.map